package org.cn3.morpho.data;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.cn3.morpho.domain.SwcDataNode;




public class FindSWCErrors {
	
	public static void main(String args[]){
		try{

			File listFile = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcData\\");
			File directoryOfFiles;
			File[] directories = listFile.listFiles();
			File[] fileList;
			
			File inputFile;
			File outputFileSolo, outputFileBunch, outputFileAll, outputDir;
			FileOutputStream fosSolo, fosBunch, fosAll;
			BufferedOutputStream bosSolo, bosBunch, bosAll; 
		    DataOutputStream dosSolo, dosBunch, dosAll;
		    String newFileData, bunchFileData = "", allFileData = "";
		    
		    String errorText;
			
		    // Loops through directories of swc file contributors
			for (int i = 0; i < directories.length; i++){
				// Makes sure we are looking at a directory
				if (directories[i].isDirectory()){
					// Gets directory containing the swc files
					directoryOfFiles = new File(directories[i].getAbsolutePath()+"\\CNG Version\\");
					fileList = directoryOfFiles.listFiles();
					// initializes data files that will be fasta formatted output for of the contributor's data
					bunchFileData = "";
					System.out.println("directory name: "+directories[i].getName()+"; full path: "+directories[i].getAbsolutePath());
					outputDir = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcErrors\\"+directories[i].getName());
					if (!outputDir.exists()){
						outputDir.mkdir();
					}
					
					// Runs through all files for a given contributor
					for (int j = 0; j < fileList.length; j++){
						inputFile = fileList[j];
						errorText = findErrors(inputFile);
						if (errorText != null){
							bunchFileData = bunchFileData.concat("Error in file "+directories[i].getName()+":"+inputFile.getName()+"; "+errorText+"\n");
						}
						/*
						if (newFileData != null){ // If null, could be glitch, could be non-dendritic file
							newFileData[0] = "> "+directories[i].getName()+" "+fileList[j].getName()+"\n"+newFileData[0];
							newFileData[1] = "> "+directories[i].getName()+" "+fileList[j].getName()+"\n"+newFileData[1];

							// Appends new file data to all of contributor's data
							bunchFileData[0] = bunchFileData[0].concat(newFileData[0].concat("\n\n"));
							bunchFileData[1] = bunchFileData[1].concat(newFileData[1].concat("\n\n"));
							
							// Writes SmallThenLarge file, then LargeThenSmalle file
							// Not Skipping writing individual files
							outputFileSolo = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcErrors\\"+directories[i].getName()+"\\"+fileList[j].getName()+".stl.out");
							fosSolo = new FileOutputStream(outputFileSolo);
							bosSolo = new BufferedOutputStream(fosSolo); 
						    dosSolo = new DataOutputStream(bosSolo);
						    dosSolo.writeBytes(newFileData[0]);
						    dosSolo.close();
	
							outputFileSolo = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcErrors\\"+directories[i].getName()+"\\"+fileList[j].getName()+".lts.out");
							fosSolo = new FileOutputStream(outputFileSolo);
							bosSolo = new BufferedOutputStream(fosSolo); 
						    dosSolo = new DataOutputStream(bosSolo);
						    dosSolo.writeBytes(newFileData[1]);
						    dosSolo.close();
	
						}
						*/
					}
					allFileData = allFileData.concat(bunchFileData);
					
					outputFileBunch = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcErrors\\"+directories[i].getName()+"Errors.txt");
					fosBunch = new FileOutputStream(outputFileBunch);
					bosBunch = new BufferedOutputStream(fosBunch); 
				    dosBunch = new DataOutputStream(bosBunch);
				    dosBunch.writeBytes(bunchFileData);
				    dosBunch.close();
				}
			}

			outputFileAll = new File("C:\\Documents and Settings\\gillette\\My Documents\\research\\swcErrors\\allErrors.txt");
			fosAll = new FileOutputStream(outputFileAll);
			bosAll = new BufferedOutputStream(fosAll); 
		    dosAll = new DataOutputStream(bosAll);
		    dosAll.writeBytes(allFileData);
		    dosAll.close();

		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	
	private static String findErrors(File inputFile) throws Exception{
		System.out.println("current file: "+inputFile.getAbsolutePath() + "; filename: "+inputFile.getName());
		FileInputStream fis = new FileInputStream(inputFile);
		
		BufferedInputStream bis = new BufferedInputStream(fis); 
	    DataInputStream dis = new DataInputStream(bis);
	    
	    SwcDataNode node, parent;
		String dataString = "";
		Map nodeMap = new HashMap();
		Pattern p = Pattern.compile(" *(\\d+) +(\\d+) +\\-?[\\.\\d]+ +\\-?[\\.\\d]+ +\\-?[\\.\\d]+ +[\\.\\d]+ +(\\-?\\d+) *");
		Matcher m;
		int nodeId, type, parentId, count = 0;
		
		while ( (dataString=dis.readLine()) != null ) {
			count++;
	        m = p.matcher(dataString);
	        //System.out.println(dataString);
	        if (m.matches()){
	        	nodeId = Integer.parseInt(m.group(1));
	        	type = Integer.parseInt(m.group(2));
	        	// Types: 1=soma, 2=axon, 3=basal dendrite, 4=apical dendrite
	        	//if (type == 1 || type == 3 || type == 4){
		      	parentId = Integer.parseInt(m.group(3));
	        	//System.out.println("nodeId: "+nodeId+"; parentId: "+parentId);
        		// Get parent from nodeMap
        		parent = (SwcDataNode)nodeMap.get(new Integer(parentId));
        		if (parentId > 0 && parent.getType() != 1 && parent.getType() != type){
        			System.out.println("Error in file "+inputFile.getAbsoluteFile()+", parentId "+parentId+" does not exist for nodeId "+nodeId+"; type "+type);
        			//return count;
        			return "line "+count+"; nodeId "+nodeId+"; type "+type+"; parentId "+parentId+"; parent type "+parent.getType();
        			//throw new Exception("Parent Id "+parentId+" does not exist");
        		}
        		// Create new node
        		node = new SwcDataNode();
        		node.setNodeId(nodeId);
        		node.setParentId(parentId);
        		node.setType(type);
        		//System
        		// Put new node in map
        		nodeMap.put(new Integer(node.getNodeId()), node);
        	}
	        m = null;
	    }
		
		return null;
	}

}