package org.cn3.morpho.domain;

public class NeuriteType implements Comparable<NeuriteType>{

	private String arborType;
	private String class1;
	private String class2;
	private String brainRegion;

	public NeuriteType(String arborType, String class1, String class2, String brainRegion){
		this.arborType = arborType;
		this.class1 = class1;
		this.class2 = class2;
		this.brainRegion = brainRegion;
	}
	public NeuriteType(String arborType){
		this.arborType = arborType;
	}
	public NeuriteType(String arborType, String class1){
		this.arborType = arborType;
		this.class1 = class1;
	}
	
	public String getArborType() {
		return arborType;
	}
	protected void setArborType(String arborType) {
		this.arborType = arborType;
	}
	public String getClass1() {
		return class1;
	}
	protected void setClass1(String class1) {
		this.class1 = class1;
	}
	public String getClass2() {
		return class2;
	}
	protected void setClass2(String class2) {
		this.class2 = class2;
	}
	public String getBrainRegion() {
		return brainRegion;
	}
	protected void setBrainRegion(String brainRegion) {
		this.brainRegion = brainRegion;
	}
	
	public NeuriteType copy(){
		return new NeuriteType(arborType,class1,class2,brainRegion);
	}
	
	public int compareTo(NeuriteType nt){
		int result = nt.getArborType().equals(arborType)?0:1; 
		if (result == 0){
			result = compareSubclasses(nt.getClass1(), class1);
		}
		if (result == 0){
			result = compareSubclasses(nt.getClass2(), class2);
		}
		if (result == 0){
			result = compareSubclasses(nt.getBrainRegion(), brainRegion);
		}
		return result;
	}
	
	private int compareSubclasses(String classA, String classB){
		int result = 0;
		if (classA == null){
			if (classB == null){
				result = 0;
			}
			else{
				result = 1;
			}
		}
		else if (classB == null){
			result = -1;
		}
		else{
			result = classA.equals(classB)?0:1;
		}
		return result;
	}
}
