package org.cn3.morpho.domain;

/**
 * 
 * @author gillette
 *
 * @param <T>
 * 
 * Wrapper class for neurite structures, connecting to that structure along
 * with any other available neuron structures and metadata.
 */
public class NeuronProcess<T extends AbstractTreeNode<T,?>> {

	private NeuronMetadata neuron;
	private Soma<T> soma;
	private TreeRoot<T> treeRoot;
	private T treeHead;
	private String arborizationType;
	private int typeId;

	public NeuronProcess(){
	}
	public NeuronProcess(T treeHead){
		this.treeHead = treeHead;
	}

	public int getTypeId() {
		return typeId;
	}
	public void setTypeId(int typeId) {
		this.typeId = typeId;
	}
	public T getTreeHead() {
		return treeHead;
	}

	public void setTreeHead(T treeHead) {
		this.treeHead = treeHead;
	}
	public NeuronMetadata getNeuron() {
		return neuron;
	}
	public void setNeuron(NeuronMetadata neuron) {
		this.neuron = neuron;
	}
	public Soma<T> getSoma() {
		return soma;
	}
	public void setSoma(Soma<T> soma) {
		this.soma = soma;
	}
	public String getArborizationType() {
		return arborizationType;
	}
	public void setArborizationType(String arborizationType) {
		this.arborizationType = arborizationType;
	}
	public TreeRoot<T> getTreeRoot() {
		return treeRoot;
	}
	public void setTreeRoot(TreeRoot<T> treeRoot) {
		this.treeRoot = treeRoot;
	}
	
}
