package org.cn3.morpho.domain;

public class SwcSecondaryData {
	
	private double localAngleOfBifurcation;
	private double remoteAngleOfBifurcation;
	private double localAngleOfElevation;
	private double remoteAngleOfElevation;
	private double pathLength;
	private double surfaceArea;
	private double volume;
	private double euclideanDistance;
	private double tortuosity = -1;
	
	public double getEuclideanDistance() {
		return euclideanDistance;
	}
	public void setEuclideanDistance(double euclideanDistance) {
		this.euclideanDistance = euclideanDistance;
		tortuosity = -1;
	}
	public double getLocalAngleOfBifurcation() {
		return localAngleOfBifurcation;
	}
	public void setLocalAngleOfBifurcation(double localAngleOfBifurcation) {
		this.localAngleOfBifurcation = localAngleOfBifurcation;
	}
	public double getPathLength() {
		return pathLength;
	}
	public void setPathLength(double pathLength) {
		this.pathLength = pathLength;
		tortuosity = -1;
	}
	public double getRemoteAngleOfBifurcation() {
		return remoteAngleOfBifurcation;
	}
	public void setRemoteAngleOfBifurcation(double remoteAngleOfBifurcation) {
		this.remoteAngleOfBifurcation = remoteAngleOfBifurcation;
	}
	public double getSurfaceArea() {
		return surfaceArea;
	}
	public void setSurfaceArea(double surfaceArea) {
		this.surfaceArea = surfaceArea;
	}
	public double getVolume() {
		return volume;
	}
	public void setVolume(double volume) {
		this.volume = volume;
	}
	public double getTortuosity() {
		if (tortuosity == -1 && euclideanDistance > 0){
			tortuosity = pathLength / euclideanDistance;
		}
		return tortuosity;
	}
	public void setTortuosity(double tortuosity) {
		this.tortuosity = tortuosity;
	}
	public double getLocalAngleOfElevation() {
		return localAngleOfElevation;
	}
	public void setLocalAngleOfElevation(double localAngleOfElevation) {
		this.localAngleOfElevation = localAngleOfElevation;
	}
	public double getRemoteAngleOfElevation() {
		return remoteAngleOfElevation;
	}
	public void setRemoteAngleOfElevation(double remoteAngleOfElevation) {
		this.remoteAngleOfElevation = remoteAngleOfElevation;
	}
	
	public SwcSecondaryData copy(){
		SwcSecondaryData copy = new SwcSecondaryData();
		copy.setEuclideanDistance(euclideanDistance);
		copy.setLocalAngleOfBifurcation(localAngleOfBifurcation);
		copy.setLocalAngleOfElevation(localAngleOfElevation);
		copy.setPathLength(pathLength);
		copy.setRemoteAngleOfBifurcation(remoteAngleOfBifurcation);
		copy.setRemoteAngleOfElevation(remoteAngleOfElevation);
		copy.setSurfaceArea(surfaceArea);
		copy.setTortuosity(tortuosity);
		copy.setVolume(volume);
		return copy;
	}
}
