package org.cn3.ns.analysis;

import java.util.Stack;

public class SequenceTraversalHelper {

	private Stack<HelperBean> helperStack = new Stack<HelperBean>();
	private HelperBean currentHelper;
	
	private class HelperBean{
		private boolean a;
		//private char character;
		private boolean foundFirstT;
		private int level;
	}
	
	public int getLevel(){
		if (currentHelper == null){
			return 0;
		}
		return currentHelper.level;
	}
	public int getBranchOrder(){
		return getLevel();
	}
	
	public void traverse(char character){
		boolean foundA;
		int parentLevel = -1;
		if (currentHelper != null) parentLevel = currentHelper.level;
		switch (character){	
		case 'A':
			// push previous currentHelper onto the stack
			if (currentHelper != null) helperStack.push(currentHelper);
			// start new currentHelper
			currentHelper = new HelperBean();
			currentHelper.a = true;
			currentHelper.foundFirstT = false;
			currentHelper.level = parentLevel + 1;
			// reassign for next character
			parentLevel = currentHelper.level;
			break;
			
		case 'C':
			// push previous currentHelper onto the stack
			if (currentHelper != null) helperStack.push(currentHelper);
			// start new currentHelper
			currentHelper = new HelperBean();
			currentHelper.a = false;
			currentHelper.level = parentLevel + 1;
			helperStack.push(currentHelper);
			// reassign for next character
			parentLevel = currentHelper.level;
		break;
			
		case 'T':
			//System.out.println();
			foundA = false;
			// Retrace up to determine whether to keep going or not
			while (currentHelper != null && !foundA){
				if (currentHelper.a){
					if (currentHelper.foundFirstT){
						// end of this A, go up a level
						currentHelper = helperStack.pop();
					}
					else{
						currentHelper.foundFirstT = true;
						foundA = true;
					}
				}
				else{
					// C node, go up a level
					currentHelper = helperStack.pop();
				}
			}
			break;
		}
	}
	
}
