package org.cn3.ns.domain;

import org.cn3.morpho.domain.NeuronMetadata;

public class FastaBean {

	private String header;
	private String sequenceName;
	private String sequence;
	private NeuronMetadata neuron;
	private String arborType;
	private boolean stl;
	
	public FastaBean(){}
	public FastaBean(String header, String sequence){
		this.header = this.sequenceName = header;
		this.sequence = sequence;
	}
	public FastaBean(String header, String sequence, String arborType){
		this.header = this.sequenceName = header;
		this.sequence = sequence;
		this.arborType = arborType;
	}
	public FastaBean(String header, String sequence, String arborType, String order){
		this.header = this.sequenceName = header;
		this.sequence = sequence;
		this.arborType = arborType;
		stl = order.equalsIgnoreCase("stl");
	}
	public FastaBean(String header, String sequence, String arborType, boolean isSTL){
		this.header = this.sequenceName = header;
		this.sequence = sequence;
		this.arborType = arborType;
		this.stl = isSTL;
	}
	
	public String getHeader() {
		return header;
	}
	public void setHeader(String header) {
		this.header = header;
	}
	public String getSequenceName() {
		return sequenceName;
	}
	public void setSequenceName(String sequenceName) {
		this.sequenceName = sequenceName;
	}
	public String getSequence() {
		return sequence;
	}
	public void setSequence(String sequence) {
		this.sequence = sequence;
	}
	public NeuronMetadata getNeuron() {
		return neuron;
	}
	public void setNeuron(NeuronMetadata neuron) {
		this.neuron = neuron;
	}
	public String getArborType() {
		return arborType;
	}
	public void setArborType(String arborType) {
		this.arborType = arborType;
	}
	public boolean isStl() {
		return stl;
	}
	public void setStl(boolean stl) {
		this.stl = stl;
	}
	public String getTraversalOrder(){
		if (stl){
			return "stl";
		}
		else{
			return "lts";
		}
	}
}
