package org.cn3.ns.nodeencoding;

import java.util.ArrayList;
import java.util.List;

import org.cn3.morpho.domain.BinaryTreeNode;

/**
 * 
 * @author gillette
 * Encodes nodes primarily by 1st order topology, then by
 * path length to the root node divided into 2 or 3 bins
 * based split equally from 0 to 95% of the maximum path length.
 *
 */
public class PathToRootEncoder extends NodeEncoder {

	private static final int DEFAULT_NUM_DIVISIONS = 1;

	private int numDivisions;
	private List<Float> distDivisions;
	
	public PathToRootEncoder(BinaryTreeNode tree){
		numDivisions = DEFAULT_NUM_DIVISIONS;
		distDivisions = getDistanceDivisions(tree,numDivisions);
	}
	public PathToRootEncoder(BinaryTreeNode tree, int numDivisions){
		this.numDivisions = numDivisions;
		distDivisions = getDistanceDivisions(tree,numDivisions);
	}
	
	private List<Float> getDistanceDivisions(BinaryTreeNode tree, int numDivisions){
		List<Float> divisions = new ArrayList<Float>(numDivisions+1);
		// #TODO write this function
		return divisions;
	}
	
	public String encodeNode(BinaryTreeNode node){
		// #TODO Finish this function
		if (node.getLeft() != null && node.getRight() != null){
			if (node.getLeft().hasChildren() && node.getRight().hasChildren()){
				return "A";
			}
			else if (node.getLeft().hasChildren() ^ node.getRight().hasChildren()){
				return "C";
			}
			else{
				return "T";
			}
		}
		return "";
	}
	
	// #TODO
	public BinaryTreeNode decodeChar(char character, BinaryTreeNode node){
		return node;
	}

	public int getNumDivisions(){
		return numDivisions;
	}
}
