package org.cn3.ns.scripts;

import java.io.File;

import org.cn3.ns.data.SwcACTWriter;
import org.cn3.ns.resources.DataProperties;

/**
 * 
 * @author gillette
 * 
 * Expects args: domainFile, queryName, domain 
 *
 */
public class ColorNeuriteByLocalAlignment {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try{
			/*
			String domainFile = args[1];
			String queryName = args[2];
			String domain = args[3];

			// Traverse domain file to extract alignment information
			*/
			File swcFile, outputDir;
			int startPos = 1;
			
			String neuriteName = "ri06-ApicalDendrite";
			//String domain = "ATACTACTACTACTACTCCATATATAC";
			String domain = "Domain Sqrt 1.5";
			//C-A-TACCTC--A-TACCTCCATC-CATAC
			//ATACTA-CTACTACTA-CTCCATAT-ATAC
			//String alignedSegment = "C-A----TAC-CTC---A----TACCTCCA-TC-CA--TAC";
			//String otherSegment   = "ATA---CTA--CTAC-TAC---TA-CTCCA-TAT-A--TAC";
			String alignedSegment = "C-A-TACCTC--A-TACCTCCATC-CATAC";
			String otherSegment   = "ATACTA-CTACTACTA-CTCCATAT-ATAC";

			neuriteName = "JBC4L-Axon";
			domain = "30% Consensus";
			alignedSegment = "-ATC-------ATA-CATT--AACTCT----------ATACTC----ATC-CT";
			otherSegment   = "CATATCACTCCATACC--TCCAA-TCTACCTCCATCCC-ACTACTCCC-ATCT";
			
			// Apical Cluster 1 50% Consensus
			//"--------A--------T------C---A-------------------------------T---C--A-----T---------C-A---T-C-C-A----------------T--C----C-C-A-------------T--C---A------T--C----C--C-T"
			// pc2b-ApicalDendrite
			//"--------A-------CT------C---A----------------------------C-CTA-TC--A-----T---ACT-C-C-A---TCC-C-A-----C----CA-TCCT--C------C-A------------CT--C---A------T--A--T-A-TC-T";
			domain = "ApicalCluster1T0.5Consensus";
			neuriteName = "pc2b-ApicalDendrite";
			
			String consensusSegment = "A-TCA--T--CAT----CAT-CCA------TCCCA-TCATC-C-CT";
			String neuriteSegment =   "ACTCACCTATCATACTCCATCCCACCATCCTC-CACTCATATATCT";
			outputDir = new File("C:/Documents and Settings/gillette/My Documents/research/papers & presentations/PASTA Paper/Paper2 - AlignmentClusteringDomains/Figures/Workspace");			

			// Apical Cluster 3 50% Consensus
			//"----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A------------------------CT-----------A---------T------C---C-----CT------------------------------------------------------------A---------C---------------------------C-----------C--T-----------A------------------------C--------T----------------------A-----------TC--------C---------------C--T"
			// 2149402-ApicalDendrite
			//"----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------A---------------------------------A-A----TA---CT---A--T----CT-----------A-----CCC-T-----CC---A--T---T------------------------------------------------------------A---------A------------T--------------C-----------C-CT-----------A-----------------C------C---C---CT----------------------A-----------TC--------C---------------ATCT";
			domain = "ApicalCluster3T0.5Consensus";
			neuriteName = "2149402-ApicalDendrite";
			
			consensusSegment = "AA-------CTA---T-CC-CTAC-CC-TA-C--TATCCC--T";
			neuriteSegment =   "AAATACTATCTACCCTCCAT-TAATCCCTACCCCTATCCATCT";
			outputDir = new File("C:/Documents and Settings/gillette/My Documents/research/papers & presentations/PASTA Paper/Paper2 - AlignmentClusteringDomains/Figures/Workspace");			

			
			// Domain alignment example
			domain = "ExampleDomain";
			neuriteName = "2149402-ApicalDendrite";
			
			consensusSegment = "AC-CC-T";
			neuriteSegment =   "AATCCCT";
			outputDir = new File("C:/Documents and Settings/gillette/My Documents/research/papers & presentations/PASTA Paper/Paper2 - AlignmentClusteringDomains/Figures/Workspace");
			startPos = 22;
			

			/*			
			String neuriteName = "02-16-09-Class1-B40X-Dendrite";
			String domain = "Consensus Sqrt 1.5";
			String alignedSegment = "---A-A---TCA---AT-CTC--------A--T---TA-----CTC------CA-CCACTCCTATC----------------------CCATCACTCATCAATCTATCCT";
			String otherSegment   = "---A-A---T-A------CTA--TC----A--TCCCTAC----CTCC-----CA-------CTC-C--C--A----CT-C-------------------------C-CCT";
*/
			/*
			String neuriteName = "11-12-09-ddaD40X1-Dendrite";
			String domain = "Consensus Sqrt 1.5";
			String alignedSegment = "CATAC--------AT-CCTA-CTCC------CACT---CT";
			String otherSegment   = "---A-ATACTATCATCCCTACCTCCCACTCCCACTCCCCT";
			*/
			//outputDir = new File("C:/Documents and Settings/gillette/My Documents/research/MultipleAlignment and Domains/");
			
			swcFile = DataProperties.getInstance().getSwcFileByName(neuriteName);
			
			//SwcACTWriter.colorNeuriteByLocalAlignment(
			//swcFile, order, neuriteName, otherName, alignedSegment, otherSegment, startPos);
			/*
			SwcACTWriter.colorNeuriteByAlignment(
					swcFile, outputDir, "STL", 
					neuriteName, domain, 
					alignedSegment, otherSegment, startPos, 
					true);
					*/
			SwcACTWriter.redrawNeuriteByAlignment(
					swcFile, outputDir, "STL", 
					neuriteName, domain, 
					neuriteSegment, consensusSegment, startPos, 
					true, true);
		} catch (Exception e){
			e.printStackTrace();
		}

	}

	
	
}
