package org.cn3.ns.scripts;

import java.util.List;
import java.util.Map;

import org.cn3.morpho.data.persistence.NeuronDAO;
import org.cn3.morpho.domain.NeuronMetadataComplete;
import org.cn3.ns.data.NSDataReader;

public class PyramidalCellChecker {

	public static void main(String args[]){
		try{
			List neurons = NeuronDAO.getInstance().getNeuronInfos();
			List sequences = NSDataReader.loadSequenceList();
			Map lengthMap = NSDataReader.loadLengthDatabase();
			int length;
			
			String name;
			NeuronMetadataComplete neuron;
			for (int i = 0; i < neurons.size(); i++){
				neuron = (NeuronMetadataComplete)neurons.get(i);
				name = neuron.getName();
				if (neuron.getCellType().equals("Pyramidal cell")
						&& !neuron.getProtocol().equals("Cultured")
						&& !neuron.getArchive().equals("Jacobs")
						&& !neuron.getArchive().equals("DeFelipe")){
					if (sequences.contains(name+"-BasalDendrite")
							&& !sequences.contains(name+"-ApicalDendrite")){
						length = ((Integer)lengthMap.get(name+"-BasalDendrite")).intValue();
						if (length > 20){
							System.out.println(name+" ("+neuron.getArchive()+") has long basal dendrite and no apical");
						}
					}
					else if (sequences.contains(name+"-ApicalDendrite")
							&& !sequences.contains(name+"-BasalDendrite")){
						length = ((Integer)lengthMap.get(name+"-ApicalDendrite")).intValue();
						if (length > 24){
							System.out.println(name+" ("+neuron.getArchive()+") has long apical dendrite and no basal");
						}
					}
				}
			}
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
}
